#!/usr/local/bin/python
#
# Usage: python hanoi.py [number_of_discs]
#
import sys
import string
from PoP import *
pop = PoP()
N = Variable('N')
N1 = Variable('N1')
A = Variable('A')
B = Variable('B')
C = Variable('C')
X = Variable('X')
Y = Variable('Y')
ANY = Variable()
LEFT = Atom('LEFT')
CENTER = Atom('CENTER')
RIGHT = Atom('RIGHT')
Hanoi = Atom('hanoi')
Move = Atom('move')
Output = Atom('output')
Sub = Atom('sub')
Is = Atom('is')
Write = Atom('write')
NL = Write('\n')
pop.assertz(Hanoi(N),
	Move(N, LEFT, CENTER, RIGHT))
pop.assertz(Move(0, ANY, ANY, ANY))
pop.assertz(Move(N, A, B, C), 
	Is(N1, Sub(N, 1)),
	Move(N1, A, C, B),
	Output(N, A, B),
	Move(N1, C, B, A))
pop.assertz(Output(N, X, Y),
	Write('move '),
	Write(N),
	Write(' from '),
	Write(X),
	Write(' to '),
	Write(Y),
	NL)
pop.listing()

if len(sys.argv) >= 2:
	discs = string.atoi(sys.argv[1])
else:
	discs = 3
pop.inquire(Hanoi(discs))
