#!/usr/local/bin/python
#
# Usage: python nqueen.py [n]
#
import sys, string
from PoP import *

pop = PoP()

Nqueen = Atom('nqueen')
Queens = Atom('queens')
Pickup = Atom('pickup')
Safe = Atom('safe')
Safepair = Atom('safepair')
Is = Atom('is')
Ne = Atom('ne')
Abs = Atom('abs')
Add = Atom('add')
Sub = Atom('sub')

A = Variable('A')
B = Variable('B')
D = Variable('D')
D1 = Variable('D1')
X = Variable('X')
Y = Variable('Y')
Z = Variable('Z')
ANY = Variable()

pop.assertz(Nqueen(X, Y),
	Queens([], X, Y))

pop.assertz(Queens(X, [], X))
pop.assertz(Queens(X, Y, Z),
	Pickup(Y, A, B),
	Safe(A, X, 1),
	Queens(List(A, tail=X), B, Z))

pop.assertz(Pickup(List(X, tail=Y), X, Y))
pop.assertz(Pickup(List(A, tail=X), Y, List(A, tail=Z)),
	Pickup(X, Y, Z))

pop.assertz(Safe(ANY, [], ANY))
pop.assertz(Safe(X, List(Y, tail=Z), D),
	Safepair(X, Y, D),
	Is(D1, Add(D, 1)),
	Safe(X, Z, D1))

pop.assertz(Safepair(X, Y, Z),
	Ne(Abs(Sub(X, Y)), Z))

pop.listing()

if len(sys.argv) >= 2:
	n = string.atoi(sys.argv[1])
else:
	n = 6

r = pop.inquire(Nqueen(range(n), X))
while r <> None:
	x = r['X']
	ans = []
	while x.type() == TYPE_list:
		ans.insert(0, x.item().value())  # reverse
		x = x.next()
	print ans
	r = pop.inquire_next()
