#!/usr/local/bin/python
import types
from PoP import *

assert Integer(3).type() == TYPE_integer
assert Integer(3).value() == 3
assert Integer(-5).value() == -5
assert type(Integer(3.4).value()) == types.IntType
assert Integer(3.4).value() == int(3.4)
try:
	Integer()
except: pass
else: assert 0
try:
	Integer('a')
except: pass
else: assert 0

assert Float(3.4).type() == TYPE_float
assert Float(3.4).value() == 3.4
assert Float(-5.6).value() == -5.6
assert type(Float(3).value()) == types.FloatType
assert Float(3).value() == float(3)
try:
	Float()
except: pass
else: assert 0
try:
	Float('a')
except: pass
else: assert 0

assert String('a').type() == TYPE_string
assert String('').value() == ''
assert String('a').value() == 'a'
try:
	String()
except: pass
else: assert 0
try:
	String(3)
except: pass
else: assert 0

assert NIL.type() == TYPE_nil

assert Variable('x').type() == TYPE_variable
assert Variable('x').name() == 'x'
assert Variable('').name() == ''
assert Variable().name() == ''
try:
	Variable(3)
except: pass
else: assert 0

assert Atom('a').type() == TYPE_atom
assert Atom('a').name() == 'a'
try:
	Atom()
except: pass
else: assert 0
try:
	Atom('')
except: pass
else: assert 0
try:
	Atom(3)
except: pass
else: assert 0
try:
	Atom('a', Atom)
except: pass
else: assert 0
arg = Atom('a', 0, 1).args()
assert type(arg) == types.ListType
assert len(arg) == 2
assert arg[0].value() == 0
assert arg[1].value() == 1
assert Atom('a', args=()).args() == []
assert Atom('a', args=[]).args() == []
arg = Atom('a', args=(0, 1)).args()
assert len(arg) == 2
for i in xrange(2): assert arg[i].value() == i
arg = Atom('a', args=[0, 1]).args()
assert len(arg) == 2
for i in xrange(2): assert arg[i].value() == i
arg = Atom('a', 0, 1, args=(2, 3)).args()
assert len(arg) == 4
for i in xrange(4): assert arg[i].value() == i
arg = Atom('a', 0, 1, args=[2, 3]).args()
assert len(arg) == 4
for i in xrange(4): assert arg[i].value() == i
a = Atom('a')
a0 = a(0)
a01 = a0(1)
assert a01.name() == 'a'
arg = a01.args()
assert len(arg) == 2
for i in xrange(2): assert arg[i].value() == i

p0 = Atom('p0')
p1 = Atom('p1')
p2 = Atom('p2')
assert Clause(p0).type() == TYPE_clause
c = Clause(p0, p1, p2)
assert c.head().name() == 'p0'
assert c.body()[0].name() == 'p1'
assert c.body()[1].name() == 'p2'
c = Clause(p0, body=(p1, p2))
assert c.head().name() == 'p0'
assert c.body()[0].name() == 'p1'
assert c.body()[1].name() == 'p2'
c = Clause(p0, body=[p1, p2])
assert c.head().name() == 'p0'
assert c.body()[0].name() == 'p1'
assert c.body()[1].name() == 'p2'
c = Clause(p0, p1, body=(p2,))
assert c.head().name() == 'p0'
assert c.body()[0].name() == 'p1'
assert c.body()[1].name() == 'p2'
c = Clause(p0, p1, body=[p2])
assert c.head().name() == 'p0'
assert c.body()[0].name() == 'p1'
assert c.body()[1].name() == 'p2'
assert Clause(p0).is_fact()
assert not Clause(p0).is_rule()
assert Clause(p0).is_rule_or_fact()
assert not Clause(p0).is_query()
assert not Clause(p0, p1).is_fact()
assert Clause(p0, p1).is_rule()
assert Clause(p0, p1).is_rule_or_fact()
assert not Clause(p0, p1).is_query()
assert not Clause(None, p1).is_fact()
assert not Clause(None, p1).is_rule()
assert not Clause(None, p1).is_rule_or_fact()
assert Clause(None, p1).is_query()
try:
	Cluase()
except: pass
else: assert 0
try:
	Cluase(Clause)
except: pass
else: assert 0
try:
	Cluase(None)
except: pass
else: assert 0
try:
	Clause(p0, body=p1)
except: pass
else: assert 0

L = List(0, 1, 2)
assert L.type() == TYPE_list
assert L.item().value() == 0
for i in xrange(1, 3):
	L = L.next()
	assert L.item().value() == i
assert L.next().type() == TYPE_nil
L = List(items=(0, 1, 2))
assert L.item().value() == 0
for i in xrange(1, 3):
	L = L.next()
	assert L.item().value() == i
assert L.next().type() == TYPE_nil
L = List(items=[0, 1, 2])
assert L.item().value() == 0
for i in xrange(1, 3):
	L = L.next()
	assert L.item().value() == i
assert L.next().type() == TYPE_nil
L = List(0, items=(1, 2))
assert L.item().value() == 0
for i in xrange(1, 3):
	L = L.next()
	assert L.item().value() == i
assert L.next().type() == TYPE_nil
try:
	List()
except: pass
else: assert 0

z = [
	3,
	Integer(3),
	4.5,
	Float(4.5),
	'abc',
	String('abc'),
	NIL,
	[],
	Variable('x'),
	Atom('a'),
	Clause(Atom('h')),
	[1, 2],
	List([1, 2]),
]
zt = [
	TYPE_integer,
	TYPE_integer,
	TYPE_float,
	TYPE_float,
	TYPE_string,
	TYPE_string,
	TYPE_nil,
	TYPE_nil,
	TYPE_variable,
	TYPE_atom,
	TYPE_clause,
	TYPE_list,
	TYPE_list,
]
assert map(lambda x: x.type(), Atom('a', args=z).args()) == zt
assert map(lambda x: x.type(), Clause(Atom('a'), body=z).body()) == zt
x = List(items=z)
i = 0
while x.type()== TYPE_list:
	assert x.item().type() == zt[i]
	x = x.next()
	i = i + 1
x = List(0, tail=z).next()
i = 0
while x.type()== TYPE_list:
	assert x.item().type() == zt[i]
	x = x.next()
	i = i + 1
